#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string>
#include <stdio.h>
#include <ctype.h>
#include <iostream>


using namespace std;

enum types {TYPE_UNDEF, TYPE_BYTE, TYPE_UBYTE,
                        TYPE_WORD, TYPE_UWORD,
                        TYPE_LONG, TYPE_ULONG,
                        TYPE_PROC};

// Dump the symbol table
void DumpTable(void);

// Look for symbol in table
bool InTable(string s);

// Check if a symbol is in the table, report an error if not
void CheckTable(string Symbol);

// Find the parameter number
int ParamNumber(string N);

// Find the parameter type 
int ParamType(string N);

// See if an identifier is a parameter
bool IsParam(string N);

// Add a new parameter to the table
void AddParam (string Name, int Type, string InitialValue);

// Initialize parameter table to null
void ClearParams();

// Return an identifiers type
int TypeOf (string Identifier);

// Check the symbol table for a duplicate identifier
// Report an error if identifier is already in table
void CheckDup(string Symbol);

// Add a new entry to the symbol table
void AddEntry(string Name, int Type);

// Set number of params of a proc
void SetNumParams (string Name, int NumParams);

// Check number of params of a proc
void CheckNumParams (string Name, int NumParams);


